=== debian/changelog ===
paperwork (2.2.2-2) unstable; urgency=medium

  * debian/rules: Generate png and AUTHORS data in dh_auto_build target
  * debian/patches: Add patch to fix running chkworkdir cli command

 -- Thomas Perret <thomas.perret@phyx.fr>  Sun, 07 Apr 2024 23:55:10 +0200

paperwork (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2
  * debian/control:
    + Switch build system to pyproject
    + Drop unused dependency (Mitigates: #1061434)
    + Add new dependency
    + Add missing dependencies
  * debian/patches:
    + Refresh patches
    + Drop patch applied upstream
    + Split flaky test for autopkgtest (Closes: #1059633)
  * debian/copyright:
    + Update Copyright authors and years
    + Update package upstream metadata
  * debian/rules:
    + Add/Improve comments in build system
    + Clean after build as per policy (Closes: #1049118, #1049533)
    + Build sphinx documentation in standard location
  * debian/NEWS: Document JPEG to PNG migration
  * debian/u/metadata: Update package upstream metadata
  * debian/watch:
    + drop filename mangling
    + update checking URL

 -- Thomas Perret <thomas.perret@phyx.fr>  Sun, 07 Apr 2024 12:30:02 +0200
