=== debian/tests/control ===
Tests: dangerous-plugins-disabled
Depends: @
Restrictions: allow-stderr

Tests: unittests
Depends: @, python3-pytest, python3-pytest-cov, python3-psutil, libreoffice
Restrictions: allow-stderr

Tests: unittests-flaky
Depends: @, python3-pytest, libreoffice
Restrictions: allow-stderr, flaky

Tests: check-deps
Depends: @, jq, libreoffice
Restrictions: allow-stderr

Test-Command: /usr/bin/paperwork-gtk --help
Depends: paperwork-gtk
Restrictions: superficial, allow-stderr
Features: test-name=paperwork
