=== debian/watch ===
version=4
opts=uversionmangle=s/\.post/post/ \
  https://gitlab.gnome.org/World/OpenPaperwork/paperwork/-/tags?sort=updated_desc archive/@ANY_VERSION@/@PACKAGE@-\d\S*\.tar\.gz
opts=component=test-documents \
  https://gitlab.gnome.org/World/OpenPaperwork/paperwork-test-documents/-/tags?sort=updated_desc archive/@ANY_VERSION@/@PACKAGE@-test-documents-\d\S*\.tar\.gz ignore uupdate
